#include <bits/stdc++.h>
using namespace std;
#define ll long long
ll mod = 1e9 + 9;

bool is_psp(string &s) {
    queue<char> q;
    for (char c : s) {
        if (empty(q) && c == ')') return false;
        if (c == '0') continue;
        if (!empty(q) && (q.back() == '(' && c == ')')) q.pop();
        else q.push(c);
    }
    if (!empty(q)) return false;
    return true;
}

int main() {
    int n, k; cin >> n >> k;
    vector<string> psp;
    for (int j = 0; j < pow(3, n); j++) {
        int x = j; string s = "";
        for (int st = n - 1; st >= 0; st--) {
            int u = x / pow(3, st);
            if (u == 0) s += '0';
            if (u == 1) s += '(';
            if (u == 2) s += ')';
            x %= int(pow(3, st));
        }
        psp.push_back(s);
    }
    vector<string> better;
    for (string s : psp) {
        if (is_psp(s)) {
            better.push_back(s);
        }
    }
    ll cnt = 0;
    for (string s : better) {
        vector<pair<int, int>> pref(n + 1); pref[0] = {0, 0};
        int max_dif = 0;
        for (int i = 1; i < n + 1; i++) {
            pref[i].first = pref[i - 1].first + int(s[i - 1] == '(');
            pref[i].second = pref[i - 1].second + int(s[i - 1] == ')');
            max_dif = max(max_dif, abs(pref[i].first - pref[i].second));
        }
        if (max_dif == k) cnt++; cnt %= mod;
    }
    cout << cnt;
}