#include <bits/stdc++.h>
using namespace std;
#define ll long long
ll mod = 1e9 + 9;

ll ceshka(ll n, ll k) {
    ll res = 1;
    for (ll i = n; i > n - k; i--) {
        res *= i; res /= (n + 1 - i);
        res %= mod;
    }
    return res;
}


bool is_psp(string &s) {
    queue<char> q;
    for (char c : s) {
        if (empty(q) && c == ')') return false;
        if (!empty(q) && (q.back() == '(' && c == ')')) q.pop();
        else q.push(c);
    }
    if (!empty(q)) return false;
    return true;
}

int depth(string &s) {
    int n = s.size();
    vector<pair<int, int>> pref(n + 1); pref[0] = {0, 0};
    int max_dif = 0;
    for (int i = 1; i < n + 1; i++) {
        pref[i].first = pref[i - 1].first + int(s[i - 1] == '(');
        pref[i].second = pref[i - 1].second + int(s[i - 1] == ')');
        max_dif = max(max_dif, abs(pref[i].first - pref[i].second));
    }
    return max_dif;
}

int main() {
    int n, k; cin >> n >> k;
    vector<vector<string>> all(n + 1);
    for (int i = 0; i < n + 1; i++) {
        for (int j = 0; j < pow(2, i); j++) {
            int x = j; string s = "";
            for (int st = i - 1; st >= 0; st--) {
                int u = x / pow(2, st);
                if (u == 0) s += '(';
                if (u == 1) s += ')';
                x %= int(pow(2, st));
            }
            all[i].push_back(s);
        }
    }
    vector<vector<string>> psp(n + 1);
    for (int i = 0; i < n + 1; i++) {
        for (string s : all[i]) {
            if (is_psp(s)) {
                psp[i].push_back(s);
            }
        }
    }
    vector<int> depths_k(n + 1, 0);
    for (int i = 0; i < n + 1; i++) {
        for (string s : psp[i]) {
            int y = depth(s);
            if (y == k) depths_k[i]++;
        }
    }
    ll cnt = 0;
    for (int i = 0; i < n + 1; i++) {
        cnt += (depths_k[i] * ceshka(n, i)) % mod;
    }
    cout << cnt;
}