#include <bits/stdc++.h>
using namespace std;
#define ll long long

int perebor(vector<ll> &v, int t, int m) {
    vector<ll> pref(m + 1, 0);
    for (int i = 1; i <= m; i++) {
        pref[i] = pref[i - 1] + v[i - 1];
    }
    int u = 0; bool found = false;
    for (int mid = 0; mid < t; mid++) {
        ll ans = 0;
        for (int i = 0; i + mid - 1 < m; i++) {
            ans = pref[i + mid] - pref[i];
            if (ans >= t) return mid;
        }
    }
    return -1;
}

vector<int> stress(int n) {
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        v[i] = (1, 1e7);
    }
}


int main() {
    ll m, t; cin >> m >> t;
    vector<ll> v(m); for (int i = 0; i < m; i++) cin >> v[i]; bool was = false;
    vector<ll> pref(m + 1, 0);
    for (int i = 1; i <= m; i++) {
        pref[i] = pref[i - 1] + v[i - 1];
    }
    int l = 0; int r = m + 1;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        ll ans = 0;
        for (int i = 0; i + mid - 1 < m; i++) {
            ans = max(ans, pref[i + mid] - pref[i]);
            if (ans >= t) was = true;
        }
        if (ans < t) {
            l = mid;
        } else {
            r = mid;
        }
    }
    // if (!was) cout << -1 << endl;
    // else cout << r << endl;
    cout << perebor(v, t, m);
}